// Copyright (c) 2017 PlanGrid, Inc.

import React, { Component } from 'react';

import ReactDataGrid from 'react-data-grid';
import CSV from 'comma-separated-values';

class CsvViewer extends Component {

  static parse(data) {
    const rows = [];
    const columns = [];

    console.log({data})
    const unformattedRows = (data || "").split("\n");

    let parsedData = [];

    unformattedRows.forEach(unformattedRow => {
      parsedData.push((unformattedRow || "").split(","))
    })


    console.log({parsedData})

    parsedData.forEach((array) => {
      console.log({array})
      if (columns.length < 1) {
        array.forEach((cell, idx) => {
          columns.push({
            key: `key-${idx}`,
            name: cell,
            resizable: true,
            sortable: true,
            filterable: true,
          });
        });
      } else {
        const row = {};
        array.forEach((cell, idx) => {
          row[`key-${idx}`] = cell;
        });
        rows.push(row);
      }
    });

    console.log({rows, columns})
    return { rows, columns };
  }

  constructor(props) {
    super(props);
    this.state = CsvViewer.parse(props.data);
  }

  componentWillReceiveProps(nextProps) {
    this.setState(CsvViewer.parse(nextProps.data));
  }

  render() {
    const { rows, columns } = this.state;

    return (
      <React.Fragment>
        <p>
          {JSON.stringify(columns || [])}
          {JSON.stringify(rows || [])}
        </p>

        <ReactDataGrid
          columns={columns}
          rowsCount={rows.length}
          rowGetter={i => rows[i]}
          minHeight={this.props.height || 650}
        />
      </React.Fragment>
    );
  }
}

export default CsvViewer;
